
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <math.h>
#include <string.h>

unsigned int far *vmptr = (unsigned int far *)0xA0000000L;
char *infile1 = NULL;
char *infile2 = NULL;

int paging = 0;

unsigned int port_adr = 0x278;
int DisplayFormat = '1';
int DisplayRes = '1';
int invert_image = 0;
int image_1_byte = 8;
int image_2_byte = 4;
int reading_gif = 0;
int got_second_image = 0;
int first_image = 1;
int c;
int page2 = 0;
int size_512k = 0;
int size_1024k = 0;
int xmode = 2;

FILE *df;


void parse_command(int, char **);
void set_image_1();
void set_image_2();
void check_file_names();

main(argc,argv)
int argc;
char **argv;
{

    printf("3DGV Version 0.23 Experimental\n");
    printf("(c) Copyright 1992 John Swenson\n");
    printf("Parts from the PoVRay raytracer (c) Copyright 1991 The PoV Team\n");
    if(argc < 2)
    {
        printf("3DGV [<left GIF> <right GIF>] | [MIG GIF] -D<disp_type> -S<vidmem>\n");
        printf("The first image in the MIG is the left, the second is the right\n");
        printf("your video board must have twice the usual amount of memory\n");
        printf("necessary for a particular video mode, ie. 1 meg for 640x480\n");
        printf("Sega 3D glasses must be attached to the parallel port\n");
        printf("-d is followed by 2 characters, first is type second is resolution,\n");
        printf("   it must be present, currently there is no auto detect.\n");
        printf("-s is followd by '5' or '10', -s5 means 512k and -s10 means 1024k\n");
        printf("   video ram. This MUST be specified to use SVGA modes. \n");
        printf("-p specifies the parallel port -p1 or -p2. You can also specify\n");
        printf("   a specific port address: -px3c7 uses port 3c7 hex.\n");
        exit(1);
    }

    /* df = fopen("3ddebug.lst","w"); */

    parse_command(argc,argv);
    check_file_names();



    Read_Gif_Image(infile1);
    if(!got_second_image && (infile2 != NULL))
    {
        set_image_2();
        first_image = 0;
        Read_Gif_Image(infile2);
    }

    while(1)
    {
        if(kbhit())
        {
            c = getch();
            if(c == 'i' || c == 'I')
                invert_image = !invert_image;
            else
                break;
        }
        while((inp(0x3da) & 8)!=0);
        while(!((inp(0x3da) & 8)!=0));
        if(page2==0)
        {
            set_image_2();
        }
        else
        {
            set_image_1();
        }
    }



    display_close();
}



void parse_command(argc,argv)
int argc;
char **argv;
{
        int i;
        char temp[100];
        char *str;
        int mem;
        
        for(i = 1; i < argc; i++)
        {
                str = argv[i];
                if(str[0] == '-')
                {
                        switch(str[1])
                        {
                                case 's' :
                                case 'S' :

                                        mem = atoi(str+2);
                                        switch(mem)
                                        {
                                            case 5:
                                                size_512k = 1;
                                                break;
                                            case 10:
                                                size_1024k = 1;
                                                break;
                                        }
                                        break;
                                case 'd' :
                                case 'D' :
                                        if( *(str+2) != '\0')
                                            DisplayFormat = *(str+2);
                                        else
                                            break;
                                        if(*(str+3) != '\0')
                                            DisplayRes = *(str+3);
                                        break;
                                case 'i' :
                                case 'I' :
                                    invert_image = 1;
                                    break;
                                case 'x' :
                                case 'X' :
                                    xmode = atoi(str+2);
                                    break;
                                case 'P' :
                                case 'p' :
                                    if(*(str+2) == 'x')
                                    {
                                        sscanf(str+3,"%x", &port_adr);
                                        break;
                                    }
                                    switch(atoi(str+2))
                                    {
                                        case 1 :
                                            port_adr = 0x378;
                                            break;
                                        case 2 :
                                            port_adr = 0x278;
                                            break;
                                        default:
                                            printf("unknown port number %s\n",str+2);
                                            exit(1);
                                    }
                                    break;
                                default : printf("Unknown option %s\n",str);
                                        exit(1);
                                break;
                        }
                }
                else
                {
                        if(infile1 == NULL)
                                infile1 = str;
                        else if(infile2 == NULL)
                                infile2 = str;
                        else
                        {
                                printf("Too many file names\n");
                                exit(1);
                        }
                }
        }
}

void check_file_names()
{
    char temps[100];
    char *c;

    if(infile1 != NULL)
    {
        c = strchr(infile1,'.');
        if(c == NULL)
        {
            strcpy(temps,infile1);
            strcat(temps,".gif");
            infile1 = (char *)malloc(strlen(temps)+2);
            strcpy(infile1,temps);
        }
    }
    if(infile2 != NULL)
    {
        c = strchr(infile2,'.');
        if(c == NULL)
        {
            strcpy(temps,infile2);
            strcat(temps,".gif");
            infile2 = (char *)malloc(strlen(temps)+2);
            strcpy(infile2,temps);
        }
    }
}
